## Installation
```
npm install git+https://git.wm-app.xyz/dev/csharp-process.git
```
or
```
yarn add git+https://git.wm-app.xyz/dev/csharp-process.git
```

## Usage
in C#
```cs
class Program : NodeProcess
{
    static void Main(string[] args)
    {
        NodeSharp.Start(new Program());
    }

    public override void OnAction(NodeParam param, RPCHandle rpc)
    {
        
        rpc.Send(" ==> test " + param.data);
    }
}
```
in node
```js
import Porcess from 'csharp-process'

const service = new Process('./demo.exe',result => {
	console.log('result:',result)
},error => {
	console.log('error:',error)
});

try {
    const result = await service.send('hello csharp', 'test');
    console.log('process result:', result)
} catch (e) {
    console.log('process Error:', e)
}
```